#ifndef _WRAPSOCK_H

#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <errno.h>

#include <lib/exception.h>

int Socket(int domain, int type, int protocol, EXCEPTION *ex);
int Bind(int sockfd, struct sockaddr *my_addr, socklen_t addrlen,
         EXCEPTION *ex);
int Listen(int s, int backlog, EXCEPTION *ex);
int Accept(int s, struct sockaddr *addr, socklen_t *addrlen, EXCEPTION *ex);
int Connect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen,
            EXCEPTION *ex);
int Getsockopt(int s, int level, int optname, void *optval, socklen_t *optlen,
               EXCEPTION *ex);
int Setsockopt(int s, int level, int optname, const void *optval,
               socklen_t optlen, EXCEPTION *ex);
int Send(int s, const void *msg, size_t len, int flags, EXCEPTION *ex);
int Recv(int s, void *buf, size_t len, int flags, EXCEPTION *ex);

#endif /* _WRAPSOCK_H */
