#ifndef _IPT_EDGEMARK_H
#define _IPT_EDGEMARK_H

#include <asm/types.h>

/*
 * edge mark
 */

#ifdef __DEBUG__
#define DEBUGP(fmt, args...) printk(fmt, ##args)
#else
#define DEBUGP(fmt, args...) {}
#endif

#define EDGEMARK_OPTLEN (sizeof(struct edgemark_opt))
#define EDGEMARK_IPHLEN (sizeof(struct iphdr) + EDGEMARK_OPTLEN)
#define EDGEMARK_OPTPTR(iph) \
  ((struct edgemark_opt *) (((__u8 *) iph) + sizeof(struct iphdr)))
#define EDGEMARK_DATAPTR(iph) (((__u8 *) iph) + EDGEMARK_IPHLEN)

#define IPOPT_EDGEMARK            101
#define EDGEMARK_MSGTYPE_MARK     1  // indicate marked packets
#define EDGEMARK_MSGTYPE_START    2  // control to start marking
#define EDGEMARK_MSGTYPE_STOP     3  // control to stop marking
#define EDGEMARK_MSGTYPE_RESET    4  // control to reset counters

struct edgemark_opt {
  __u8 type;            // IPOPT_EDGEMARK
  __u8 length;          // EDGEMARK_OPTLEN
  __u8 msgtype;         // EDGEMARK_MSGTYPE_XXX
  __u8 mark_distance;
  __u32 mark_start;
  __u32 mark_end;
};

struct ipt_edgemark_target_info {
	unsigned long markprob;
	unsigned long markprob_unscaled;
};

#endif /* _IPT_EDGEMARK_H */
