#ifndef _TRACEBACK_H
#define _TRACEBACK_H

#include <router/ddos/edgemark/edgemark.h>
#include <router/ddos/traceback/attackgraph.h>
#include <math.h>
#include <gmp.h>         /* All GMP programs need to include gmp.h */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// ---------- calLocalTrafficRate --------------------------------------------

int calLocalTrafficRate(RouterTree* head, const MarkingFieldsNode* fieldList,
                        int time, double markp);
double calTrafficRateIn(const MarkingFieldsNode* fieldList,
                        const double* trafficRate,
                        unsigned long toIp);
double calTrafficRateOut(const MarkingFieldsNode* fieldList,
                         const double* trafficRate,
                         unsigned long fromIp);
int numOfNode(const MarkingFieldsNode* fieldList);
int calLocalTrafficRateNode(RouterTree* node,
                            const MarkingFieldsNode* fieldList,
                            const double* trafficRate);
int calLocalTrafficRate(RouterTree* head, const MarkingFieldsNode* fieldList,
                        int time, double markp);


// ---------- calMinStableTime -----------------------------------------------
double calMinStableTime (double markp, double target, double init_end,
                         int maxd, double* localTrafficRate);
int poisson(int op,mpf_t *t,int maxk,mpf_t *a, mpf_t *b, mpf_t *c, mpf_t *p,
            mpf_t *sum);


#endif /* _TRACEBACK_H */
