#ifndef _RAWSOCK_H
#define _RAWSOCK_H

#include <arpa/inet.h>
#include <linux/ip.h>
#include <router/ipqext/rsp.h>

#define RAW_IPH_LEN sizeof(struct iphdr)

struct raw_struct {
  int sd;
  struct in_addr src_addr;
  struct in_addr dst_addr;
  struct sockaddr_in sockaddr;
  __u8 protocol;
  struct iphdr iph;          // normal 20-byte header
  struct rsphdr rsph;        // RSP header
  unsigned char *data;
  int data_len;
};

int create_raw_socket(struct raw_struct *raw);
void gen_raw_packet(struct raw_struct *raw);
void free_raw_packet(struct raw_struct *raw);
int send_raw_packet(struct raw_struct *raw);
void raw_socket_test();

#endif /* _RAWSOCK_H */
