#include <lib/exception.h>

static void vprintf_fp(FILE *fp, const char *fmt, va_list ap)
{
  char buf[EXCEPTION_STRING_MAXLEN];

#ifdef HAVE_VSNPRINTF
  vsnprintf(buf, sizeof(buf), fmt, ap); /* safe */
#else
  vsprintf(buf, fmt, ap);               /* not safe */
#endif
  strcat(buf, "\n");
  fputs(buf, fp);
  fflush(fp);
}

DEFINE_EXCEPTION(exception_null)
{
  return ret;
}

DEFINE_EXCEPTION(exception_ret)
{
  va_list ap;

  va_start(ap, fmt);
  vprintf_fp(stderr, fmt, ap);
  va_end(ap);

  return ret;
}

DEFINE_EXCEPTION(exception_exit)
{
  va_list ap;

  va_start(ap, fmt);
  vprintf_fp(stderr, fmt, ap);
  va_end(ap);

  exit(ret);
}
