#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

int ioutil_buffer_to_file(const char *buf, int len, const char *filename)
{
  FILE *fp;
  int ret;

  fp = fopen(filename, "wb+");
  if (fp == NULL)
    return -1;

  ret = fwrite(buf, 1, len, fp);
  fclose(fp);

  return (ret == len) ? 0 : -1;
}

/*
 * loop read until the specified length of data is read
 */
ssize_t readn(int inSock, void *outBuf, size_t inLen) {
  size_t  nleft;
  ssize_t nread;
  char *ptr;

	/*
    assert(inSock >= 0);
    assert(outBuf != NULL);
    assert(inLen > 0);
	*/

  ptr = (char*) outBuf;
  nleft = inLen;

  while(nleft > 0) {
    nread = read(inSock, ptr, nleft);

    if (nread < 0) {
      if (errno == EINTR)
        nread = 0;  // interupted, call read again
      else
        return -1;  // error
    }
    else if (nread == 0)
			return 0;
    //      break;        // EOF

    nleft -= nread;
    ptr += nread;
  }

  return (inLen - nleft);
}


/*
 * loop write until the specified length of data is written
 */
ssize_t writen(int inSock, const void *inBuf, size_t inLen) {
  size_t  nleft;
  ssize_t nwritten;
  const char *ptr;

	/*
    assert(inSock >= 0);
    assert(inBuf != NULL);
    assert(inLen > 0);
	*/

  ptr   = (char*) inBuf;
  nleft = inLen;

	//	set_fl(inSock, O_NONBLOCK);

  while(nleft > 0) {


		nwritten = write(inSock, ptr, nleft);
		
    if (nwritten <= 0) {
      if (errno == EINTR)
        nwritten = 0; // interupted, call write again
      else {
        return -1;    // error
			}
    }

		nleft -= nwritten;
		ptr += nwritten;
		
		/*
      if (nwritten > 0) {
			nleft -= nwritten;
			ptr += nwritten;
      }
		*/
  }

	//	clr_fl(inSock, O_NONBLOCK);

  return inLen;
}
