#ifndef _IPSEND_H
#define _IPSEND_H

#include <linux/ip.h>
#include <linux/netdevice.h>

#define __DEBUG_IPSEND__
#ifdef __DEBUG_IPSEND__
#define DEBUGP(fmt, args...) printk("%s:%d:"fmt, __FUNCTION__, __LINE__, ##args)
#else
#define DEBUGP(fmt, args...) {}
#endif

#define IPPROTO_IPSEND             250
#define IPOPT_IPSEND               (100 | IPOPT_CONTROL)

#define IPSEND_OPTLEN (sizeof(struct ipsend_opt))
#define IPSEND_IPHLEN (sizeof(struct iphdr) + IPSEND_OPTLEN)
#define IPSEND_OPTPTR(iph) \
  ((struct ipsend_opt *) (((__u8 *) iph) + sizeof(struct iphdr)))
#define IPSEND_DATAPTR(iph) (((__u8 *) iph) + IPSEND_IPHLEN)

#define IPSEND_MSGTYPE_DATA  1

// ipsend IP option
struct ipsend_opt {
  __u8 type;            // IPOPT_IPSEND
  __u8 length;          // IPSEND_OPTLEN
  __u8 msgtype;         // IPSEND_MSGTYPE_XXX
  __u8 padding;         // zero-padding
  __u32 seqno;
};

int ipsend_send_data(__u32 saddr, __u32 daddr, __u32 seqno, __u32 lastudp);

#endif /* _IPSEND_H */
