#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <lib/util.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <router/ddos/edgemark/emmsg.h>

// program information
const char *program_version = "0.1";
const char *program_name = "emctl";

int main(int argc, char **argv)
{
  __u32 localaddr;
  __u32 remoteaddr;

  if (argc != 4) {
    printf("%s v%s\n\n"
           "Usage: %s src_ip dest_ip action\n\n"
           "Action: s - start edge marking process\n"
           "        x - stop edge marking process\n"
           "        r - reset internal statistics\n\n",
           program_name, program_version, program_name);
    exit(1);
  }

  localaddr = inet_addr(argv[1]);
  remoteaddr = inet_addr(argv[2]);

  if (strcmp(argv[3], "s") == 0) {
    emmsg_send_control(localaddr, remoteaddr, EDGEMARK_MSGTYPE_START);
  } else if (strcmp(argv[3], "x") == 0) {
    emmsg_send_control(localaddr, remoteaddr, EDGEMARK_MSGTYPE_STOP);
  } else if (strcmp(argv[3], "r") == 0) {
    emmsg_send_control(localaddr, remoteaddr, EDGEMARK_MSGTYPE_RESET);
  } else {
    printf("Invalid option.\n");
  }

  return 0;
}
