#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <lib/util.h>
#include <lib/net/rawsock.h>
#include <router/ddos/snapshot/snapshot.h>
#include <router/ddos/snapshot/ssmsg.h>

#define DATA_BUFSIZE 2000
#define hline() \
  printf("------------------------------------------------------------------------------\n")

int main(int argc, char **argv)
{
  rawsock_t raw;
  int totlen, datalen;
  struct snapshot_opt *opt;

  memset(&raw, 0, sizeof(rawsock_t));

  if (rawsock_alloc_data(&raw, DATA_BUFSIZE) == NULL)
    ERR_RET(-1);

  if (rawsock_create_socket(&raw, IPPROTO_SNAPSHOT) < 0)
    ERR_RET(-1);

  raw.opt.optlen = SNAPSHOT_OPTLEN;

  while ((totlen = rawsock_recv(&raw)) > 0) {

    hline();

    printf("totlen = %d\n", totlen);
    bufdump(&(raw.iph), sizeof(struct iphdr));
    ssmsg_dump_iphdr(&(raw.iph));

    hline();

    bufdump(&(raw.opt), SNAPSHOT_OPTLEN);
    opt = (struct snapshot_opt *) &(raw.opt);
    ssmsg_dump_opt(opt);

    hline();

    datalen = totlen - sizeof(struct iphdr) - SNAPSHOT_OPTLEN;
    printf("datalen = %d\n", datalen);
    bufdump(raw.data, datalen);
    ssmsg_dump_msg(opt, raw.data, datalen);

    hline();
  }

  rawsock_free_data(&raw);

  close(raw.sd);

  return 0;
}
