/*
    myArs.h
    Function header
*/

#include <math.h>
#include <limits.h>
//#include "paulslib.h"
#include "ar.h"
#include "ar.c"
#include "ne.c"

typedef struct blockInfoNode
{
    double scv;
    int    numOfPacket;
    double mean;        // packet size mean
    struct blockInfoNode* next;
    
    // the following 2 is for testing data stroage:
    double pastPredictSCV;
    double pastPredictNumOfPacket;
} BlockInfoNode;

typedef struct ARS_info
{
    // variable for the on-going block 
    int* packetSizeArray;
    int packetSizeArraySize;
    int numOfSample;
    // variable for past data
    BlockInfoNode* blockInfo;
    int numOfHistory;
    int U;
    int V;
    double relativeError;
    double probabilityOfError;

    double predictSCV;
    double predictCount;

} ARS_info;



//////////////////////////
// Exteral function     //
//////////////////////////
/*
 *  function for a block of data
 */
int ARS_initARS_info(ARS_info* info, int V, int U, double relativeError, double probabilityOfError);

int ARS_initBlock(ARS_info *ars_info, int packetSizeArraySize);
int ARS_addSample(ARS_info *ars_info, int packetSize);
int ARS_finishBlock(ARS_info *ars_info, int numOfPacket, 
            int* predictSamplingCount, double* predictSamplingProb);

void ARS_FreeARS_info(ARS_info* info);


