
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "/root/FYP/csim/gpp/lib/cpp.h"
#include "/root/FYP/csim/gpp/lib/csim.h"


#define DEBUG

#include "myArs.h"
#include "myArs.c"

#include "changeDetect.c"

#define TOTAL_TIME 100000


//EVENT send_event[5];
event_set send_event("send_event", 5);

int packetSize[5];

extern "C" void sim(int, char**);

void timer0()
{
    int i;
    
    create("timer0");
    for (i=0; i<TOTAL_TIME/100; i++)
    {
        hold(100.0);
        send_event[0].set();
    }
}

void sender1()
{
    int i;
    
    create("sender1");
    for (i=0; i<TOTAL_TIME/5; i++)
    {
        hold(expntl(5.0));
        packetSize[1] = 50;
        send_event[1].set();
    }
}

void sender2()
{
    int i;
    
    create("sender2");
    for (i=0; i<TOTAL_TIME/10; i++)
    {
        hold(expntl(10.0));
        packetSize[2] = 100;
        send_event[2].set();
    }
}

void sender3()
{
    int i;
    
    create("sender3");
    for (i=0; i<TOTAL_TIME/20; i++)
    {
        hold(expntl(20.0));
        packetSize[3] = 100;
        send_event[3].set();
    }
}

void sender4()
{
    int i;
    
    create("sender4");
    for (i=0; i<TOTAL_TIME/1; i++)
    {
        if (i < TOTAL_TIME/3)
        {
            hold(1.0);
        }
        else
        {
            //hold(expntl(1.0));
            hold(1.0);
            packetSize[4] = 150;
            send_event[4].set();
        }
    }
}


void sim(int argc, char** argv)
{
    int i;
    int event_index;
    ARS_info* ars_info;
    int numOfPacket;
    int samplingSize=100;
    double samplingProb=1;

    // exp mean cal:
    double passVolume=0;
    double nowVolume=0;
    double a = 0.5;
    double detectThreshold=50000;

    // for Change Detection
    ChangeDetectStruct* changeDetectS = NULL;
    CalibrateStruct* calibrateS;
    
    // calculate the real rate and predict rate
    double realNowVolume=0;
    double realOldVolume=0;
    double predictNowVolume=0;
    double predictOldVolume=0;

    
    //changeDetectS = NewChangeDetectStruct(10000, detectThreshold);
    calibrateS = NewCalibrateStruct(100);
    
    ars_info = (ARS_info*)malloc(sizeof(ARS_info));

    ARS_initARS_info(ars_info, 5, 300, 0.1, 0.1);
    
    //event_set(send_event, "send_event", 5);
    set_model_name("TESTING");
    create("sim");
    //reseed(NULL, time(NULL));     //seed random
    reseed(NULL, 10000);

    
    timer0();
    sender1();
    sender2();
    sender3();
    sender4();
    
    numOfPacket = 0;
    ARS_initBlock(ars_info, samplingSize);
    for (i=0; i<TOTAL_TIME/100; )  // syn with the timer0
    {
        event_index = send_event.wait_any();
        if (event_index == 0)
        {
            i++;
            if (numOfPacket > 0)
            {
                ARS_finishBlock(ars_info, numOfPacket, &samplingSize, &samplingProb);
                // Sampling Size and Sample Prob
    /*            
                printf("time: %d\n", i);
                printf("mean: %lf, numOfPacket: %d\n", 
                        ars_info->blockInfo->mean,
                        ars_info->blockInfo->numOfPacket);
                printf("samplingSize: %d, samplingProb: %lf\n", 
                        samplingSize, samplingProb);
*/
                        
                nowVolume= ars_info->blockInfo->mean * ars_info->blockInfo->numOfPacket;
//                printf("%d\t%lf\t%lf\t%lf\t", i, nowVolume, passVolume, samplingProb);
  //              printf("\n");
                
                predictNowVolume = nowVolume;
                /*if (nowVolume - passVolume > detectThreshold)
                {
                    //printf("Detect at time: %d\n", i);
                    //printf("nowVolume: %lf, passVolume: %lf\n", nowVolume, passVolume);
                    printf("%d\n", detectThreshold);
                }
                else
                    printf("0\n");*/
                //printf("%lf\n", nowVolume-passVolume);
                passVolume = exp_m(passVolume, nowVolume, a);

                /*
                // Change Detection
                if (ChangeDetect(changeDetectS, nowVolume))
                    printf("Change Detected at %d\n", i);
                */
                
                //Automatic change detection tuning
                
                if (i > 100)
                    printf("%d\t", i);
                if (i < 100)
                    AddCalibrateSample(calibrateS, nowVolume);
                else if (i == 100)
                    changeDetectS =  Calibrate(calibrateS, 0);
                else if (ChangeDetect(changeDetectS, nowVolume))
                {
                    printf("!!!\n");
                    //printf("Change Detected at %d\n", i);
                }   
               
                
                /*
                // The rate of send and prediction
                printf("%d\t%lf\t%lf\t%lf\n", i, realNowVolume-realOldVolume, 
                                                 predictNowVolume-predictOldVolume,
                                                 (realNowVolume-realOldVolume - 
                                                 (predictNowVolume-predictOldVolume))/
                                                 (realNowVolume-realOldVolume));
                 
                */
                /*   
                printf("%lf\t%d\n", realNowVolume-realOldVolume - 
                                     (predictNowVolume-predictOldVolume),
                                     (int)(realNowVolume-realOldVolume));
                  */                   
                predictOldVolume = predictNowVolume;
                predictNowVolume = 0;
            }
            numOfPacket = 0;
            realOldVolume = realNowVolume;
            realNowVolume = 0;
            
            ARS_initBlock(ars_info, samplingSize);
        }
        else
        {
            if ( ((double)random(0,RAND_MAX)/RAND_MAX) <= samplingProb)
            {
                ARS_addSample(ars_info, packetSize[event_index]);
                /*
                if (ARS_addSample(ars_info, packetSize[event_index]) != 0)
                    printf("%d, ", packetSize[event_index]);
                else
                    printf("(%d), ", packetSize[event_index]);
                  */  
            }
            realNowVolume += packetSize[event_index];
            numOfPacket++;
        }
    }
    //printARSError(ars_info);
}

