#include <stdlib.h>
#include <stdio.h>

#include "myArs.h"
#include "myArs.c"

#include "exp_m.c"

int main()
{
    int i, j;
    int count;
    FILE* inFile;
    double timeStamp;
    int size;
    int oldTime, time1;
    int samplingSize=100;
    double samplingProb=1;
    double mean;

    // exp mean cal:
    double passVolume=0;
    double nowVolume=0;
    double a = 0.5;
    double detectThreshold=1250000;

    ARS_info *ars_info;

    ars_info = (ARS_info*)malloc(sizeof(ARS_info));
   
    inFile = fopen("networkSource.txt", "r");
    if (inFile == NULL)
        printf("Cannot open file!\n");
    
    ARS_initARS_info(ars_info, 5, 300, 0.1, 0.1);


    count = 0;
    oldTime = 0;
    while (1)
    {
        if (fscanf(inFile, "%lf %d", &timeStamp, &size) <= 0)
            break;
        time1 = (int)timeStamp;
        if (time1 != oldTime)
        {
            if (count > 0)
            {
                //printf("count: %d\n", count);
                ARS_finishBlock(ars_info, count, &mean, &samplingSize, &samplingProb);
                /*printf("time: %d\n", oldTime);
                printf("mean: %lf, numOfPacket: %d\n", 
                        ars_info->blockInfo->mean,
                        ars_info->blockInfo->numOfPacket);
                printf("samplingSize: %d, samplingProb: %lf\n", 
                        samplingSize, samplingProb);
                        */
                nowVolume= ars_info->blockInfo->mean * ars_info->blockInfo->numOfPacket;
                if (nowVolume - passVolume > detectThreshold)
                {
                    printf("Detect at time: %d\n", oldTime);
                    printf("nowVolume: %lf, passVolume: %lf\n", nowVolume, passVolume);
                }
                passVolume = exp_m(passVolume, nowVolume, a);
            }
            // cal ext mean:
           
            ARS_initBlock(ars_info, samplingSize);
            oldTime = time1;
            count = 0;
        }
        else
        {
            if ( ((double)random()/RAND_MAX) <= samplingProb)
            {
                ARS_addSample(ars_info, size);
            }
            count++;
        }
    }
    //printARSError(ars_info);
    fclose(inFile);
    return 0;
}


